import 'dart:collection';

import 'package:enge/makers/maker.dart';
import 'package:enge/support/io.dart';
import 'package:slugify/slugify.dart';
import 'package:sprintf/sprintf.dart';

class ComponentMaker extends Maker {
  String name;

  ComponentMaker(String name) {
    this.name = name;
  }

  @override
  String getTemplateFileName() {
    return 'component_template.template';
  }

  @override
  String getTargetPath() {
    var fileName = sprintf('%s_component.dart', [this.name.toLowerCase()]);
    fileName = Slugify(fileName);

    return IO.joinOnWorkingDir('lib', 'components', fileName);
  }

  @override
  HashMap<String, String> getVariables() {
    final variables = HashMap<String, String>();
    variables['COMPONENT_NAME'] = this.name + 'Component';

    return variables;
  }
}
