import 'dart:collection';

import 'package:cooker/cooker.dart';
import 'package:enge/support/io.dart';

abstract class Maker {
  String getTemplateFileName();
  String getTargetPath();

  HashMap<String, String> getVariables();

  String getTemplatePath() {
    final fileName = getTemplateFileName();

    return IO.joinOnLocation('lib', 'makers', 'templates', fileName);
  }

  void make() {
    Cooker(getTemplatePath(), getTargetPath(), contentVariables: getVariables())
        .generate();
  }
}
