import 'dart:collection';

import 'package:enge/makers/maker.dart';
import 'package:enge/support/io.dart';
import 'package:slugify/slugify.dart';
import 'package:sprintf/sprintf.dart';

class PageMaker extends Maker {
  String name;

  PageMaker(String name) {
    this.name = name;
  }

  @override
  String getTemplateFileName() {
    return 'page_template.template';
  }

  @override
  String getTargetPath() {
    var fileName = sprintf('%s_page.dart', [this.name.toLowerCase()]);
    fileName = Slugify(fileName);

    return IO.joinOnWorkingDir('lib', 'pages', fileName);
  }

  @override
  HashMap<String, String> getVariables() {
    final variables = HashMap<String, String>();
    variables['PAGE_NAME'] = this.name + 'Page';

    return variables;
  }
}
